"""built-in modules"""
import time
import datetime
import re
import os
from subprocess import Popen, PIPE # these commands does not require shell=True: mkdir/cat/rm/dropbox_uploader/'sudo teamviewer daemon restart'
import glob #used in uploading files
import threading
from math import log #used in calcualting doubling time
from tkinter import ttk
import tkinter as tk
import tkinter.messagebox as mbox
"""third party modules"""
import serial
from serial.tools import list_ports


global const_oxy1rs232_port

"""determine OXY1RS232 port"""
ports = list_ports.comports() #get all ports
port_oxy1rs232 = '-'
for p in ports:
    if "FT2VC051" in p.hwid:
        port_oxy1rs232 = p.device
const_oxy1rs232_port = port_oxy1rs232

print(const_oxy1rs232_port)

def send_oxy1rs232(command_text):
    """send command to Presens OXY-1 (RS232 version) oxygen meter"""
    global const_oxy1rs232_port
    ser = serial.Serial(port=const_oxy1rs232_port,baudrate=19200, bytesize=8, parity='N', stopbits=1, timeout=1)
    command= command_text + chr(13)
    ser.write(str.encode(command))
    s = ''
    count = 0
    time.sleep(0.2)
    while s == '' and count < 5:
        s = ser.read(2000)
        try:
            s = s.decode('utf-8',errors='ignore')
        except AttributeError:
            pass
        time.sleep(0.2)
        count = count + 1
    ser.close
    return s

def read_oxy1rs232():
    """let oxy1rs232 read and return a string that contains amplitude, phase, and ppb"""
    raw_output = send_oxy1rs232('data').split(';')
    amplitude = int(raw_output[1][1:])
    phase = int(raw_output[2][1:])
    ppb = round(int(raw_output[4][1:])/10,3) #PST9 (sens0006) only outputs ppmv (malt0001 for dry, oxyu0006 for ppmg, so "int(raw_output[4][1:])/10000 / 26.58" to obtain ug/L at 30 degree C
    #for pst6 (sens0003) and ppb, only "int(raw_output[4][1:])/10" (to change to ppb: malt0000 for humid, oxyu0007 for ppb)
    return str(amplitude) + "-" + str(phase) + "-" + str(ppb)

#send_oxy1rs232('sens0002') #pst3
#('calt0000') #humid
